<?php


class VueCategorie
{

/**
  * production d'une string contenant un tableau HTML représentant une catégorie
  * @param Categorie $categorie
  * @return string
  */
    public function getHTML4Categorie(Categorie $categorie): string
    {
        $ch = "<table border='1'>
        <tr><th>id_categorie</th><th>robe_bouteille</th><th>sucrage_bouteille</th><th>type_bouteille</th></tr><tr>\n";
        $ch .= "<tr><td>" . $categorie->getId_categorie() . "</td>\n";
        $ch .= "<td>" . $categorie->getRobe_bouteille() . "</td>\n";
        $ch .= "<td>" . $categorie->getSucrage_bouteille() . "</td>\n";
        $ch .= "<td>" . $categorie->getType_bouteille() . "</td>\n";
        $ch.= "</tr></table>\n";
        return $ch;
    }

    /**
     * production d'une string contenant un formulaire HTML 
     * destiné à saisir une nouvelle catégorie ou à modifier une catégorie existant
     * @param array $assoc
     * @return string
        */
    public function getFormulaire4Categorie(array $assoc): string
    {
        $ch = "<form action='".$_SERVER['PHP_SELF']."' method='GET'>\n";
        foreach ($assoc as $col => $val) {
            if (is_array($val)) {
                $ch .= "$col : <input name='$col' type='".$val['type']
                                  ."' value='".$val['default']."' />\n";
            }
            else
                $ch .= "$col : <input type='$val' name='$col' />\n";
        }
        $ch .= "<input type='submit' name='Valider' value='Sauver'/>\n";


        return $ch."</form>\n";
    }

/**
     * production d'une string contenant une liste HTML représentant un ensemble de catégories
     * et permettant de les modifier ou de les supprimer grace à un lien hypertexte
     * @param Categorie $tabCategorie un tableau d'instances de catégories
     * @return string
        */
    public function getAllCategorie(array $tabCategorie): string
    {
        $ch = "<ul>\n";
        foreach ($tabCategorie as $categorie) {
            if ($categorie instanceof Categorie) {
                $ch .= "<li>".$categorie->getId_categorie()." ";
                $ch .= $categorie->getRobe_bouteille()." ";
                $ch .= $categorie->getSucrage_bouteille()." ";
                $ch .= $categorie->getType_bouteille()." ";
                $ch .= "<a href='?action=update&id_categorie=".$categorie->getId_categorie()."'>Modifier</a> ";
                $ch .= "<a href='?action=delete&id_categorie=".$categorie->getId_categorie()."'>Supprimer</a> ";
                $ch .= "</li>\n";
            }
        }
        return $ch."</ul>\n";
    }
}

?>